package jsystem;

import java.util.*;
import kjava.io.*;
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import javax.microedition.lcdui.*;



public class TextEdit extends FileHandler implements CommandListener{
	private TextBox text	= new TextBox("","",32000,TextField.ANY);
	private Command saveCmd	= new Command("Save", Command.OK, 1);
	private Command exitCmd	= new Command("Exit", Command.OK, 1);
	private Alert 	accept	= new Alert(" "," ",null,null);
	private Command okCmd   = new Command("OK", Command.OK, 1);
	private Command cancelCmd  = new Command("Cancel", Command.OK, 1);


	private String savedText = null;
	private String fname = null;
	
	public TextEdit(){
		text.addCommand(saveCmd);
  		text.addCommand(exitCmd);
  		text.setCommandListener(this);
     	accept.addCommand(okCmd);
     	accept.addCommand(cancelCmd);
     	accept.setCommandListener(this);
		ext = new String[1];
		ext[0] = "*";
	}


	public void start(Display display, Displayable back, String fname){
		super.start(display,back,fname);
		this.fname = fname;
		String t = readFile(fname);
		if(t != null){
			text.setTitle(fname.substring(fname.lastIndexOf('/')+1));
            text.setString(t);
			savedText = t;
			display.setCurrent(text);
		}else{
			display.setCurrent(new Alert("Alert",
					  		"Could not open file "+fname,null,null),
							back);
			text.setString("");
			savedText = null;
		}
	}


	public void commandAction(Command c,
                          Displayable d){
     	if (d == text ){
        	if( c == saveCmd) {
             	final String s = text.getString();
             	if(s.length()>0){
			 		new Thread(new Runnable() {
                		public void run() {
							if(fname.startsWith("res/") ){
								display.setCurrent(new Alert("Alert",
					  				"Read-only file system.",null,null),
									text);
							}else{
                    			try{
                 					FileOutputStream fs = new FileOutputStream(fname);
                 					fs.write(s.getBytes());   
                 					fs.close();                			
               					}catch(Exception e){
									display.setCurrent(new Alert("Alert",
					  					e.toString(),null,null),
										text);
               					}
							}
							savedText = s;
                		}
            		}).start();
             	}
			}else if( c == exitCmd) {
				if(!text.getString().equals(savedText)){
              		accept.setString("Text has been changed. Really exit?");
           			display.setCurrent(accept);
        		}else{
            		stop();
             	}
			}
		}else if(d == accept){
			if( c == okCmd){
                stop();
			}else if( c == cancelCmd){
				display.setCurrent(text);
			}
		}
	}
		
	void stop(){
        display.setCurrent(back);
		text.setString("");
		savedText = null;
	}

	
	String readFile( String fname ){
		byte b[] = FileBrowser.readFile(fname);
		if(b!=null)
			return new String(b);
		else
		 return "";
	}
	
}
